<template>
    <div class="main-box">
        <Header />
        <router-view v-slot="{ Component }">
            <transition :name="transition">
                <component :is="Component" />
            </transition>
        </router-view>
    </div>
</template>

<script lang="ts">
import { Vue, Options } from "vue-class-component";
import Header from "@/components/Header.vue";

@Options({
    components: {
        Header,
    },
    watch: {
        $route() {
            if (this.first) {
                this.first = false;
            } else if (this.$route.name == "MainMenu") {
                this.transition = "slide-out";
            } else {
                this.transition = "slide-in";
            }
        },
    },
})
export default class App extends Vue {
    first = true;
    transition = "disabled";
}
</script>
<style>
@import url("https://fonts.googleapis.com/css2?family=Inter:wght@100;400&display=swap");
#app {
    font-family: "Inter", sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
}

body {
    margin: 0px;
    width: 350px;
    overflow: hidden;
}

.slide-in-leave-active,
.slide-in-enter-active,
.slide-out-leave-active,
.slide-out-enter-active {
    transition: 1s;
    position: absolute !important;
    width: 100% !important;
}

.slide-in-enter-from {
    transform: translate(100%, 0);
}
.slide-in-enter-to {
    transform: translate(0, 0);
}
.slide-in-leave-from {
    transform: translate(0, 0);
}
.slide-in-leave-to {
    transform: translate(-100%, 0);
}

.slide-out-enter-from {
    transform: translate(-100%, 0);
}
.slide-out-enter-to {
    transform: translate(0, 0);
}
.slide-out-leave-from {
    transform: translate(0, 0);
}
.slide-out-leave-to {
    transform: translate(100%, 0);
}
</style>
